<p>Vratimo se ponovno na sklop <em>usporedba</em> za koji ste prethodno napisali strukturni model
   uz pozicijsko povezivanje komponenata. Sučelje ovog sklopa ponovno je prikazano je na slici 1.</p>

<figure class="mlFigure">
<img src="@#file#(usporedbai.svg)" alt="Sučelje sklopa"><br>
<figcaption><span class="mlFigKey">Slika 1.</span> Sučelje sklopa <em>usporedba</em>.</figcaption>
</figure>

<p>VHDL-specifikacija sučelja komponente 2x2-AOI koju ćemo koristiti za realizaciju sklopa <em>usporedba</em> prikazana je u nastavku.</p>
<pre><code>ENTITY aoi22 IS PORT (
 a, b, c, d: IN std_logic;
 f: OUT std_logic
);
END aoi22;</code></pre>

<p>Obilježena logička shema sklopa <em>usporedba</em> prikazana je na slici 2.</p>

<figure class="mlFigure">
<img src="@#file#(usporedba-ob.svg)" alt="Logička shema sklopa"><br>
<figcaption><span class="mlFigKey">Slika 2.</span> Dodatno obilježena logička shema sklopa <em>usporedba</em>.</figcaption>
</figure>

<p>Primijetite interne signale: imamo dva nova dvobitna interna signala <em>ac</em> i <em>bc</em> koji
   će čuvati komplemente bitova dovedenih dvobitnih brojeva <em>a</em> i <em>b</em> te dva interna signala <em>eq0c</em> 
   i <em>eq1c</em> koji čuvaju izlaze prva dva sklopa AOI.
</p>

<form id="mojFormular" onsubmit="return false;">
<div class="mlQuestionText">
  <div>
    Vaš zadatak je sljedeći. Napišite cjelokupnu VHDL specifikaciju sklopa <code>usporedba</code>. Morate napisati
    strukturni model koji odgovara shemi prikazanoj na slici 2, i koji pri stvaranju primjeraka komponenata koristi
    povezivanje putem imena. Arhitekturu nazovite <code>strukturna2</code>.
  </div>
  <div>Naputak: ako imate višebitni signal <code>sig</code> i interni signal jednakog tipa i širine <code>sigc</code>,
       komplemente svih bitova moguće je izračunati i pospremiti jednom naredbom:<br>
       <code>sigc &lt;= not sig;</code><br>
       Iskoristite takav oblik naredbe da biste odredili komplemente ulaznih brojeva.
  </div>
  <div>Naredba:<br>
       <textarea rows="10" cols="60" id="unos" name="unos"></textarea><br>
       <button onclick="provjeri(document.getElementById('unos').value, true, 'rez'); return false;">Provjeri</button><br>
       <div id="rez"></div>
  </div>
</div>
</form>

<script src="@#file#(vhdlparser.js)" type="text/javascript" charset="utf-8"></script>
<script src="@#file#(vhdlcheckers.js)" type="text/javascript" charset="utf-8"></script>
<script src="@#file#(vhdlboolean.js)" type="text/javascript" charset="utf-8"></script>
<script>
  var konfiguracija = @#raw-text#(jsinitdata);
  document.getElementById('unos').value = konfiguracija.enteredText;

  function questionCollectUserData() {
    let v = document.getElementById('unos').value;
    return {
      enteredText: v,
      textOK: provjeri(v, false, null)
    };
  }

  function provjeri(text, verbose, izlaz) {
      try {
        let tools = new VHDLCheckerTools();
        let builder = tools.buildVHDLChecker(text, function(parser) {return parser.parseDesignUnit()});
        if(!builder.result.hasAnyErrorsOrInfos()) {

          let libNames = builder.node.libNames;
          let useNames = builder.node.useNames;
          tools.checkLibUses(builder.result, libNames, useNames, ["ieee"], [["ieee", "std_logic_1164", "all"]]);

          while(true) { // provide scoping for check-skipping...
            var targetEntity = new VHDLEntity("usporedba", [
              new VHDLPort("a", VHDLPort.MODE_IN, "std_logic_vector", new VHDLRange(1,0,VHDLRange.DIRECTION_DOWNTO)),
              new VHDLPort("b", VHDLPort.MODE_IN, "std_logic_vector", new VHDLRange(1,0,VHDLRange.DIRECTION_DOWNTO)),
              new VHDLPort("f", VHDLPort.MODE_OUT, "std_logic", null)
            ]);
            tools.compareWithTargetEntity(builder.result, builder.node.entity, targetEntity, true);
            let arch = builder.node.architecture;
            let result = builder.result;
            if(arch.archName != "strukturna2") {
              result.errorMessages.push("Naziv arhitekture treba biti 'strukturna2'. Kod Vas je: '"+arch.archName+"'. Popravite to.");
            }
            if(arch.definitions==null || arch.definitions.length===0) {
              result.errorMessages.push("Deklaracijski dio arhitekture (dio prije 'BEGIN') mora sadržavati definicije zadanih internih signala - kod Vas je prazan. Popravite to.");
              break;
            }
            if(!provjeriInterneSignale(builder.result, arch.definitions, [
              new VHDLSigConstDeclaration(VHDLParser.SC_SIGNAL, "ac", new VHDLTNRangedName("std_logic_vector", new VHDLRange(1,0,VHDLRange.DIRECTION_DOWNTO)), null),
              new VHDLSigConstDeclaration(VHDLParser.SC_SIGNAL, "bc", new VHDLTNRangedName("std_logic_vector", new VHDLRange(1,0,VHDLRange.DIRECTION_DOWNTO)), null),
              new VHDLSigConstDeclaration(VHDLParser.SC_SIGNAL, "eq0c", new VHDLTNSimpleName("std_logic"), null),
              new VHDLSigConstDeclaration(VHDLParser.SC_SIGNAL, "eq1c", new VHDLTNSimpleName("std_logic"), null)
            ])) {
              break;
            }
            if(arch.statements==null || arch.statements.statements==null || arch.statements.statements.length != 5) {
              result.errorMessages.push("U tijelu arhitekture morate napisati točno 5 naredbi: tri za stvaranje potrebnih komponenata te dvije za izračun komplemenata predanih brojeva.");
            }
            if(arch.statements==null || arch.statements.statements==null) {
              break;
            }
            if(tools.checkNoDuplicateNames(builder.result, builder.node)) break;
            let usableNames = tools.extractUsableRWNames(builder.node);
            let defExpressions = {};
            let defCompInst = {};
            tools.concCommandsIterate(builder.node, function(c) {
              if(c.nodeType == VHDLParser.TN_COMPONENT_INST) {
                defCompInst[c.label] = c;
                return;
              }
              if(c.nodeType != VHDLParser.TN_CONDITIONAL_SIGNAL_ASSIGNMENT) {
                result.errorMessages.push("Pronađena je uporaba nedopuštene vrste naredbe.");
                return;
              }
              if(c.target.nodeType != VHDLParser.TN_SIMPLE_NAME) {
                result.errorMessages.push("U ovom zadatku, na lijevoj strani izraza dodjeljivanja smijete koristiti samo imena jednobitnih signala; nije dopuštena uporaba raspona, agregacija i slično.");
                return;
              }
              if(c.waveforms.length > 1 || c.waveforms[0].condition != null) {
                result.errorMessages.push("Nije dozvoljena uporaba konstrukta WHEN. Pronađena je naredba koja to koristi.");
                return;
              }
              if(c.waveforms[0].waveform.delay != null) {
                result.errorMessages.push("Nije dozvoljena uporaba kašnjenja. Pronađena je naredba koja to koristi.");
                return;
              }
              if(!tools.checkNameIsValid(usableNames, c.target.name)) {
                result.errorMessages.push("'"+c.target.name+"' je nepoznato ime.");
                return;
              }
              if(!tools.checkNameIsWritable(usableNames, c.target.name)) {
                result.errorMessages.push("'"+c.target.name+"' se ne može nalaziti s lijeve strane operatora pridruživanja.");
                return;
              }
              let tnm = c.target.name.toLowerCase();
              if(defExpressions[tnm] === undefined) {
                defExpressions[tnm] = c.waveforms[0].waveform.expression;
              } else {
                result.errorMessages.push("Više puta definirate vrijednost za '"+c.target.name+"'. U ovom zadatku to nije dopušteno.");
                return;
              }
            });
            provjeriIzraz(result, "ac", defExpressions, "a");
            provjeriIzraz(result, "bc", defExpressions, "b");
            provjeriCompInst(result, "c1", defCompInst, "aoi22", [["a",new VHDLTNIndexedName("a",0)], ["b",new VHDLTNIndexedName("b",0)], ["c",new VHDLTNIndexedName("ac",0)], ["d",new VHDLTNIndexedName("bc",0)], ["f",new VHDLTNSimpleName("eq0c")]]);
            provjeriCompInst(result, "c2", defCompInst, "aoi22", [["a",new VHDLTNIndexedName("a",1)], ["b",new VHDLTNIndexedName("b",1)], ["c",new VHDLTNIndexedName("ac",1)], ["d",new VHDLTNIndexedName("bc",1)], ["f",new VHDLTNSimpleName("eq1c")]]);
            provjeriCompInst(result, "c3", defCompInst, "aoi22", [["a",new VHDLTNSimpleName("eq0c")], ["b",new VHDLTNSimpleName("eq0c")], ["c",new VHDLTNSimpleName("eq1c")], ["d",new VHDLTNSimpleName("eq1c")], ["f",new VHDLTNSimpleName("f")]]);
            break;
          } // end-while-loop
        }
        if(verbose) {
          tools.generateHTMLResultRepresentation(builder.result, izlaz);
        }

        if(builder.result.hasAnyErrorsOrInfos()) {
          return false;
        }
        return true;
      } catch(errx) {
        if(verbose) document.getElementById(izlaz).innerHTML = "<strong>Napisani kod ne može se parsirati.</strong><br>Prijavljena greška je: "+(errx.message===undefined ? errx : errx.message);
        return false;
      }
  }

  function provjeriInterneSignale(result, definitionsArray, allowedSignals) {
    function findSigDef(name) {
      let nm = name.toLowerCase();
      for(let i = 0; i < allowedSignals.length; i++) {
        if(allowedSignals[i].name.toLowerCase() === nm) return allowedSignals[i];
      }
      return null;
    }
    function compareDefs(def1, def2) {
      if(def1.kind != def2.kind) {
        result.errorMessages.push("'"+def2.name+"' treba biti deklariran kao '"+def2.kind+"' a deklariran je kao '"+def1.kind+"'");
        return false;
      }
      if(def1.typeSpec.nodeType != def2.typeSpec.nodeType) {
        result.errorMessages.push("'"+def2.name+"' ima deklariran pogrešan tip podataka.");
        return false;
      }
      if(def1.typeSpec.nodeType === VHDLParser.TN_SIMPLE_NAME) {
        if(def1.typeSpec.name.toLowerCase() != def2.typeSpec.name.toLowerCase()) {
          result.errorMessages.push("'"+def2.name+"' ima deklariran pogrešan tip podataka; očekivano je '"+def2.typeSpec.name+"'.");
          return false;
        }
      } else if(def1.typeSpec.nodeType === VHDLParser.TN_RANGED_NAME) {
        if(def1.typeSpec.name.toLowerCase() != def2.typeSpec.name.toLowerCase()) {
          result.errorMessages.push("'"+def2.name+"' ima deklariran pogrešan tip podataka; očekivano je '"+def2.typeSpec.name+"'.");
          return false;
        }
        if(def1.typeSpec.range.rangeStart != def2.typeSpec.range.rangeStart) {
          result.errorMessages.push("'"+def2.name+"': očekivano je da raspon krene od vrijednosti '"+def2.typeSpec.range.rangeStart+"'.");
          return false;
        }
        if(def1.typeSpec.range.rangeEnd != def2.typeSpec.range.rangeEnd) {
          result.errorMessages.push("'"+def2.name+"': očekivano je da raspon ide do vrijednosti '"+def2.typeSpec.range.rangeEnd+"'.");
          return false;
        }
        if(def1.typeSpec.range.rangeDirection != def2.typeSpec.range.rangeDirection) {
          result.errorMessages.push("'"+def2.name+"': očekivano je da raspon bude u smjeru '"+def2.typeSpec.range.rangeDirection+"'.");
          return false;
        }
      } else {
        result.errorMessages.push("'"+def2.name+"' ima deklariran pogrešan tip podataka.");
        return false;
      }
      return true;
    }

    let errs = false;
    let foundSignals = new VHDLCIStringArray();
    for(let i = 0; i < definitionsArray.length; i++) {
      let def = definitionsArray[i];
      if(def.nodeType != VHDLParser.TN_SIGCONST_DECLARATION) {
        result.errorMessages.push("U deklaracijskom dijelu arhitekture pronađena nedozvoljena naredba.");
        errs = true;
        continue;
      }
      foundSignals.push(def.name);
      if(def.kind != VHDLParser.SC_SIGNAL) {
        result.errorMessages.push("U deklaracijskom dijelu arhitekture pronađena deklaracija za '"+def.kind+"'. Smijete deklarirati samo interne signale.");
        errs = true;
        continue;
      }
      if(def.initializer != null) {
        result.errorMessages.push("U deklaraciji internog signala trenutno ne smijete koristiti inicijalizaciju.");
        errs = true;
        continue;
      }
      let targetDef = findSigDef(def.name);
      if(targetDef != null) {
        if(!compareDefs(def, targetDef)) errs = true;
      }
    }
    if(errs) return false;
    let expectedSignals = new VHDLCIStringArray();
    for(let i = 0; i < allowedSignals.length; i++) { expectedSignals.push(allowedSignals[i].name); }
    let missingSignals = expectedSignals.copy().removeAll(foundSignals);
    if(missingSignals.size()>0) {
      result.errorMessages.push("U deklaracijskom dijelu arhitekture nedostaju definicije za "+missingSignals+".");
      errs = true;
    }
    let extraSignals = foundSignals.copy().removeAll(expectedSignals);
    if(extraSignals.size()>0) {
      result.errorMessages.push("U deklaracijskom dijelu arhitekture pronađene su nepotrebne definicije za "+extraSignals+".");
      errs = true;
    }
    return !errs;
  }

  function provjeriCompInst(result, targetName, defCompInst, expectedEntityName, expectedNames) {
    let stmt = defCompInst[targetName];
    if(stmt===undefined) {
      result.errorMessages.push("Niste specificirali naredbu koja stvara komponentu '" + targetName + "'.");
      return;
    }
    if(stmt.entityName.length != 2 || stmt.entityName[0].toLowerCase() != "work" || stmt.entityName[1].toLowerCase() != expectedEntityName.toLowerCase()) {
      result.errorMessages.push("Primjerak '" + targetName + "' mora biti primjerak sklopa '"+expectedEntityName+"' iz biblioteke 'work'. Kod Vas je: "+stmt.entityName.join(".")+".");
      return;
    }
    if(stmt.portMap==null || stmt.portMap.length != expectedNames.length) {
      result.errorMessages.push("Kod stvaranja primjerka '" + targetName + "', očekivano je da se u port map listi navede "+expectedNames.length+" signal(a). Kod Vas to nije slučaj.");
      return;
    }
    let shouldNames = expectedNames.map(function(e) {return e[0].toLowerCase()});
    for(let i = 0; i < expectedNames.length; i++) {
      let gi = stmt.portMap[i];
      if(gi.formalPart == null) {
        result.errorMessages.push("Kod stvaranja primjerka '" + targetName + "', zadano je da morate koristiti povezivanje putem imena. Kod vas to nije slučaj.");
        continue;
      }
      if(gi.formalPart.nodeType != VHDLParser.TN_SIMPLE_NAME) {
        result.errorMessages.push("Kod stvaranja primjerka '" + targetName + "', pozicija "+(i+1)+" bi trebala imati jednostavno ime porta - to nije slučaj.");
        continue;
      }
      let lookForName = gi.formalPart.name.toLowerCase();
      let eiIndex = expectedNames.findIndex(function(e) {return e[0].toLowerCase() === lookForName});
      if(eiIndex===-1) {
        result.errorMessages.push("Kod stvaranja primjerka '" + targetName + "', pozicija "+(i+1)+" pokušava povezati port '"+gi.formalPart.name+"', ali taj ne postoji.");
        continue;
      }
      let ei = expectedNames[eiIndex][1];
      let ind = shouldNames.indexOf(lookForName);
      if(ind===-1) {
        result.errorMessages.push("Kod stvaranja primjerka '" + targetName + "', pozicija "+(i+1)+" duplicira povezivanje za port '"+gi.formalPart.name+"'.");
        continue;
      }
      shouldNames.splice(ind, 1);
      if(gi.actualPart.nodeType != ei.nodeType) {
        result.errorMessages.push("Kod stvaranja primjerka '" + targetName + "', pozicija "+(i+1)+" nije u skladu sa zadanom shemom.");
        continue;
      }
      if(ei.nodeType===VHDLParser.TN_SIMPLE_NAME) {
        if(ei.name.toLowerCase() != gi.actualPart.name.toLowerCase()) {
          result.errorMessages.push("Kod stvaranja primjerka '" + targetName + "', pozicija "+(i+1)+" nije u skladu sa zadanom shemom.");
          continue;
        }
      } else if(ei.nodeType===VHDLParser.TN_INDEXED_NAME) {
        if(ei.name.toLowerCase() != gi.actualPart.name.toLowerCase() || ei.index != gi.actualPart.index) {
          result.errorMessages.push("Kod stvaranja primjerka '" + targetName + "', pozicija "+(i+1)+" nije u skladu sa zadanom shemom.");
          continue;
        }
      } else if(ei.nodeType===VHDLParser.TN_RANGED_NAME) {
        if(ei.name.toLowerCase() != gi.actualPart.name.toLowerCase() || ei.range.rangeStart != gi.actualPart.range.rangeStart || ei.range.rangeEnd != gi.actualPart.range.rangeEnd || ei.range.rangeDirection != gi.actualPart.range.rangeDirection) {
          result.errorMessages.push("Kod stvaranja primjerka '" + targetName + "', pozicija "+(i+1)+" nije u skladu sa zadanom shemom.");
          continue;
        }
      } else {
         result.errorMessages.push("Kod stvaranja primjerka '" + targetName + "', na poziciji "+(i+1)+" pronađen nedopušten izraz.");
         continue;
       }
    }
    if(shouldNames.length > 0) {
      result.errorMessages.push("Kod stvaranja primjerka '" + targetName + "', ostalo je nepovezanih portova: '"+shouldNames.join(", ")+"'.");
    }
  }

  function provjeriIzraz(result, targetName, defExpressions, expectedName) {
    let expr = defExpressions[targetName];
    if(expr===undefined) {
      result.errorMessages.push("Niste specificirali izraz za signal " + targetName);
      return;
    }
    if(expr.nodeType != VHDLParser.TN_UNARY_OPERATOR || expr.operName != "not" || expr.child.nodeType != VHDLParser.TN_SIMPLE_NAME || expr.child.name.toLowerCase() != expectedName) {
      result.errorMessages.push("Za signal " + targetName + " napišite naredbu koja doslovno kaže da se isti računa kao komplement od "+ expectedName+".");
      return;
    }
  }
</script>

